package de.kreawi.trainer;

import java.io.Serializable;

public class QuestionAttributes implements Serializable {

	private static final long serialVersionUID = -6421063192501048517L;

	public final static int CARD_BOX_LEVEL_UNDEFINED = -1;

	private final int questionId;

	private int cardBoxLevel;
	
	private long cardBoxTimestamp = 0;

	public QuestionAttributes(int questionId) {
		this.questionId = questionId;
		this.cardBoxLevel = CARD_BOX_LEVEL_UNDEFINED;
	}

	public int getCardBoxLevel() {
		return cardBoxLevel;
	}

	public void setCardBoxLevel(int cardBoxLevel) {
		if (cardBoxLevel >= 0 || cardBoxLevel == CARD_BOX_LEVEL_UNDEFINED) {
			this.cardBoxLevel = cardBoxLevel;
			this.cardBoxTimestamp = System.currentTimeMillis();
		} else
			throw new IllegalArgumentException(
					"Card box level must be >=0 or CARD_BOX_LEVEL_UNDEFINED!");

	}
	
	public long getCardBoxTimestamp() {
		return cardBoxTimestamp;
	}

	public int getQuestionId() {
		return questionId;
	}
}