package de.kreawi.trainer;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class QuestionAttributesModel implements Serializable {

	private static final long serialVersionUID = 5789131184547734984L;

	private Map<Integer, QuestionAttributes> attributes;

	QuestionAttributesModel() {
		this.attributes = new HashMap<Integer, QuestionAttributes>();
	}

	QuestionAttributes getQuestionAttributes(int questionId) {
		return attributes.get(questionId);
	}

	void addQuestionAttributes(QuestionAttributes attributes) {
		this.attributes.put(attributes.getQuestionId(), attributes);
	}

	void setQuestionAttributes(
			Map<Integer, QuestionAttributes> questionAttributes) {
		this.attributes = questionAttributes;
	}

	Collection<Integer> getQuestionIds() {
		return this.attributes.keySet();
	}

	Collection<Integer> getQuestionIdsForCardBoxLevel(int cardBoxLevel) {
		HashSet<Integer> ret = new HashSet<Integer>();

		for (QuestionAttributes qa : this.attributes.values()) {
			if (qa.getCardBoxLevel() == cardBoxLevel) {
				ret.add(qa.getQuestionId());
			}
		}

		return ret;
	}

	void setCardBoxLevel(int questionId, int cardBoxLevel) {
		QuestionAttributes qa = getAttributesNonFailing(questionId);
		qa.setCardBoxLevel(cardBoxLevel);
	}

	int getCardBoxLevel(int questionId) {
		QuestionAttributes qa = getAttributesNonFailing(questionId);
		return qa.getCardBoxLevel();
	}
	
	long getCardBoxTimestamp(int questionId) {
		QuestionAttributes qa = getAttributesNonFailing(questionId);
		return qa.getCardBoxTimestamp();
	}

	private QuestionAttributes getAttributesNonFailing(int questionId) {
		QuestionAttributes qa = this.attributes.get(questionId);
		if (qa == null) {
			qa = new QuestionAttributes(questionId);
			this.attributes.put(questionId, qa);
		}
		return qa;
	}
}
