package de.kreawi.trainer.db;

import org.javalite.activejdbc.Base;
import org.javalite.activejdbc.Model;

public class Setting extends Model {
  
  public static final String DB_ID = "id";
  public static final String DB_KEY = "key";
  public static final String DB_VALUE = "value";

  /** Don't use any functions of activejdbc.Model before creating the table! **/ 
  public static void createTableIfNotExists() {
    final String tableName = "settings";
    final String createQuery = "CREATE TABLE IF NOT EXISTS " + tableName + " (" +
        DB_ID + " INT AUTO_INCREMENT PRIMARY KEY, " +  
        DB_KEY + " VARCHAR(255) NULL, " +
        DB_VALUE + " VARCHAR(255) NULL" +
        ");";
    Base.exec(createQuery);
    final String indexQuery = "CREATE INDEX IF NOT EXISTS key_index ON " + tableName + "(" + DB_KEY + ")";
    Base.exec(indexQuery);
  }

  public String getKey() {
    return getString(DB_KEY);
  }

  public String getValue() {
    return getString(DB_VALUE);
  }
  
  public void setValue(final String value) {
    set(DB_VALUE, value);
  }


}
