package de.kreawi.trainer.dialogs;

import java.awt.GridBagLayout;

import javax.swing.JPanel;

import com.jgoodies.forms.factories.Borders;

import de.kreawi.trainer.TrainerFrame;
import javafx.application.Platform;
import javafx.embed.swing.JFXPanel;
import javafx.geometry.Insets;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.layout.Background;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;

public class FxDialog extends JPanel {

  public FxDialog(final String name, final Pane pane) {

    setLayout(new GridBagLayout());
    setOpaque(false);
    setBorder(Borders.DIALOG_BORDER);

    final JFXPanel jfxPanel = new JFXPanel();
    
    jfxPanel.setMaximumSize(TrainerFrame.FRAME_SIZE);
    
    this.add(jfxPanel);

    Platform.runLater(new Runnable() {
      @Override
      public void run() {
        final KreawiInternalFrameFx kif = new KreawiInternalFrameFx(name, pane);
        final BorderPane root = new BorderPane(kif);
        root.setBackground(Background.EMPTY);
        root.setMinSize(MainDialogFx.DIALOG_WIDTH, MainDialogFx.DIALOG_HEIGHT);
        root.setPrefSize(MainDialogFx.DIALOG_WIDTH, MainDialogFx.DIALOG_HEIGHT);
        root.setMaxSize(MainDialogFx.DIALOG_WIDTH, MainDialogFx.DIALOG_HEIGHT);
        BorderPane.setMargin(kif, new Insets(MainDialogFx.GRID_SPACING));
        final Scene scene = new Scene(root);
        scene.setFill(Color.TRANSPARENT);
        
        jfxPanel.setScene(scene);
        jfxPanel.setOpaque(false);
      }
    });
    
  }
}
