package de.kreawi.trainer.dialogs.onlineGame;

import javafx.geometry.Insets;
import javafx.scene.layout.BorderPane;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.scene.text.TextAlignment;

public class ErrorPage extends BorderPane {

  public ErrorPage(String message) {
    getStylesheets().add("/de/kreawi/trainer/dialogs/kreawi_internal_frame.css");

    // apply same gradient as internal frame to list
    getStyleClass().add("kif_content");
    // kif_content_with_title for rounded corners only on bottom
    getStyleClass().add("kif_content_with_title");
    

    setStyle("-fx-background-color: rgba(255, 255, 255, 0.9)");
    
    final Text caption = new Text(message);
    caption.setTextAlignment(TextAlignment.CENTER);
    final double padding = 30d;
    caption.wrappingWidthProperty().bind(widthProperty().subtract(padding * 2d));
    caption.setFont(Font.font("Arial, sans-serif", FontWeight.BOLD, 14d));
    
    setCenter(caption);
    BorderPane.setMargin(caption, new Insets(padding));
  }
  
}
