package de.kreawi.trainer.dialogs.onlineGame;

import java.util.List;

import de.kreawi.trainer.dialogs.onlineGame.custom_nodes.HeaderWithBackbutton;
import de.kreawi.trainer.dialogs.onlineGame.custom_nodes.OGButton;
import de.kreawi.trainer.dialogs.onlineGame.custom_nodes.Subheader;
import de.kreawi.trainer.dialogs.onlineGame.custom_nodes.UserListView;
import de.kreawi.trainer.onlinegame.entities.OnlineGameUser;
import javafx.geometry.Pos;
import javafx.scene.control.Button;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;

public class FriendsList extends BorderPane {
  
  private final List<OnlineGameUser> friendsList;
  private final Runnable arbitraryOpponentAction;
  private final OnlineGameContainer onlineGameContainer;
  
  public FriendsList(final List<OnlineGameUser> friendsList, final Runnable arbitraryOpponentAction,
      final OnlineGameContainer onlineGameContainer) {
    super();
    
    this.friendsList = friendsList;
    this.arbitraryOpponentAction = arbitraryOpponentAction;
    this.onlineGameContainer = onlineGameContainer;
    
    final Runnable backAction = () -> {
      this.onlineGameContainer.showDashboard();
    };
    final HeaderWithBackbutton header = new HeaderWithBackbutton("Freunde", backAction);
    
    final Button arbitraryOpponent = new OGButton("Beliebiger Spieler", "Beliebigen Spieler einladen",
        this.arbitraryOpponentAction);
    final HBox buttonContainer = new HBox(arbitraryOpponent);
    buttonContainer.setMinHeight(50d);
    buttonContainer.setAlignment(Pos.CENTER);
    
    
    final VBox noScroll = new VBox();
    noScroll.getChildren().add(header);
    noScroll.getChildren().add(buttonContainer);
    setTop(noScroll);
    
    setCenter(new UserListView(this.friendsList, new Subheader("Freunde"), this.onlineGameContainer));
  }
}
