package de.kreawi.trainer.dialogs.selection;

import java.util.Map;

import javax.swing.Action;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.jquizengine.questions.collection.QuestionPool;

import de.kreawi.trainer.TrainerFrame;
import de.kreawi.trainer.TrainerFrame.Actions;
import de.kreawi.trainer.TrainerModel;
import de.kreawi.trainer.TrainerSettingsConstants;

public class MCCategorySelectionDialog extends CategorySelectionDialog {

	private static final long serialVersionUID = -6174449623980719715L;

	private static final Logger logger = LoggerFactory.getLogger(MCCategorySelectionDialog.class); 

  public MCCategorySelectionDialog(TrainerFrame mainframe, TrainerModel model, Map<Actions, Action> actionMap,
      QuestionPool questionPool) {
    super(mainframe, model, actionMap, questionPool);
  }
	
	protected boolean showCardBoxPanel() {
	  return true;
	}

	@Override
	protected boolean showCardBoxFilterOption() {
	  return true;
	}

	@Override
	protected boolean showExamMode() {
		return true;
	}
	
	@Override
	protected String getSelectionToolTipText() {
		return getSelectionToolTiptextImpl("SELECTION_LABEL_CATEGORY_SELECTION_MC_EXPLANATION");
	}

	@Override
	protected String getExplanationMessageKey() {
		return TrainerSettingsConstants.KEY_SHOW_CATEGORY_SELECTION_MC_EXPLANATION_MESSAGE;
	}

}
