package de.kreawi.trainer.dialogs.selection;

import java.util.Map;

import javax.swing.Action;

import com.jquizengine.questions.collection.QuestionPool;

import de.kreawi.trainer.TrainerFrame;
import de.kreawi.trainer.TrainerFrame.Actions;
import de.kreawi.trainer.TrainerModel;
import de.kreawi.trainer.TrainerSettingsConstants;

public class TextCategorySelectionDialog extends CategorySelectionDialog {

	private static final long serialVersionUID = -5110560939967473458L;

  public TextCategorySelectionDialog(TrainerFrame mainframe, TrainerModel model, Map<Actions, Action> actionMap,
      QuestionPool questionPool) {
    super(mainframe, model, actionMap, questionPool);
  }
	
	protected boolean showCardBoxPanel() {
	  return false;
	}

	@Override
	protected boolean showCardBoxFilterOption() {
		/*
		 * as text question are always counted as correct, flashcard box is
		 * not supported at the moment
		 */
		return false;
	}

	@Override
	protected boolean showExamMode() {
		/* Exam mode makes no sense at all for text questions! */
		return false;
	}
	
	@Override
	protected String getSelectionToolTipText() {
		return getSelectionToolTiptextImpl("SELECTION_LABEL_CATEGORY_SELECTION_TEXT_EXPLANATION");
	}

	@Override
	protected String getExplanationMessageKey() {
		return TrainerSettingsConstants.KEY_SHOW_CATEGORY_SELECTION_TEXT_EXPLANATION_MESSAGE;
	}

}
