package de.kreawi.trainer.onlinegame.entities;

public class OnlineGameNotification {
  
  public enum NotificationType {
    CHALLENGE_INVITATION,
    CHALLENGE_REJECTED,
    CHALLENGE_ACCEPTED,
    CHALLENGE_INVITATION_SENT,
    QUIZ_INVITATION,
    QUIZ_INVITATION_SENT,
    QUIZ_ACCEPTED,
    QUIZ_REJECTED,
    QUIZ_CHALLENGE_PENDING,
    SELECT_TOPIC,
    QUIZ_CHALLENGE_STARTED,
    QUIZ_CHALLENGE_ROUND_PLAYING,
    QUIZ_CHALLENGE_ROUND_WAITING,
    QUIZ_CHALLENGE_WON,
    QUIZ_CHALLENGE_LOSE,
    QUIZ_CHALLENGE_DRAW,
    FINISHED
  }

  private String notificationId;
  
  private String quizChallengeId;
  
  private String message;
  
  private long milliseconds;
  
  private boolean read;
  
  private String type;
  
  private String recordType;
  
  private String senderId;
  
  private String receiverId;
  
  private String userName;
  
  private String profileImage;
  
  private int roundNo;
  
  private boolean singlePlayer; 
  
  private boolean threadStatus;
  
  public OnlineGameNotification() {
  }

  public String getNotificationId() {
    return notificationId;
  }

  public void setNotificationId(String notificationId) {
    this.notificationId = notificationId;
  }

  public String getQuizChallengeId() {
    return quizChallengeId;
  }

  public void setQuizChallengeId(String quizChallengeId) {
    this.quizChallengeId = quizChallengeId;
  }

  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public long getMilliseconds() {
    return milliseconds;
  }

  public void setMilliseconds(long milliseconds) {
    this.milliseconds = milliseconds;
  }

  public boolean isRead() {
    return read;
  }

  public void setRead(boolean read) {
    this.read = read;
  }

  public NotificationType getType() {
    return NotificationType.valueOf(type);
  }

  public void setType(String type) {
    this.type = type;
  }

  public String getRecordType() {
    return recordType;
  }

  public void setRecordType(String recordType) {
    this.recordType = recordType;
  }

  public String getSenderId() {
    return senderId;
  }

  public void setSenderId(String senderId) {
    this.senderId = senderId;
  }

  public String getReceiverId() {
    return receiverId;
  }

  public void setReceiverId(String receiverId) {
    this.receiverId = receiverId;
  }

  public String getUserName() {
    return userName;
  }

  public void setUserName(String userName) {
    this.userName = userName;
  }

  public String getProfileImage() {
    return profileImage;
  }

  public void setProfileImage(String profileImage) {
    this.profileImage = profileImage;
  }

  public int getRoundNo() {
    return roundNo;
  }

  public void setRoundNo(int roundNo) {
    this.roundNo = roundNo;
  }

  public boolean isSinglePlayer() {
    return singlePlayer;
  }

  public void setSinglePlayer(boolean singlePlayer) {
    this.singlePlayer = singlePlayer;
  }

  public boolean isThreadStatus() {
    return threadStatus;
  }

  public void setThreadStatus(boolean threadStatus) {
    this.threadStatus = threadStatus;
  }

  @Override
  public String toString() {
    return "OnlineGameNotification [type=" + type + ", quizChallengeId=" + quizChallengeId + ", message=" + message
        + ", notificationId=" + notificationId + ", milliseconds=" + milliseconds + ", read=" + read + ", recordType="
        + recordType + ", senderId=" + senderId + ", receiverId=" + receiverId + ", userName=" + userName
        + ", profileImage=" + profileImage + ", roundNo=" + roundNo + ", singlePlayer=" + singlePlayer
        + ", threadStatus=" + threadStatus + "]";
  }
  
  

}
