package de.kreawi.trainer.onlinegame.net;

import java.net.URL;
import java.util.HashMap;

import javax.imageio.ImageIO;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.kreawi.trainer.onlinegame.OnlineGameModel;
import de.kreawi.trainer.onlinegame.entities.OnlineGameFriendList;
import de.kreawi.trainer.onlinegame.entities.OnlineGameUser;

public class OnlineGameUserListCommunicator extends OnlineGameCommunicator {
  
  private final Logger logger = LoggerFactory.getLogger(OnlineGameUserListCommunicator.class); 

  public OnlineGameUserListCommunicator(OnlineGameModel model) {
    super(model);
    // TODO Auto-generated constructor stub
  }

  public void getFriendList(final String userId, final FriendListReceiver onSuccess, final Runnable onFailure) {
    
    final HashMap<String, String> parameters = new HashMap<String, String>();
    parameters.put("userId", userId);
    
    final String path = "/getFriendList";
    
    try {
      
      final OnlineGameFriendList friendList = receiveJsonData(path, parameters, OnlineGameFriendList.class);
      
      for (OnlineGameUser user : friendList.getNormal()) {
        user.setFriend(true);
      }
      
      onSuccess.run(friendList);
      
    } catch (Exception e) {

      logger.error("Error while receiving friend list!", e);
      
      onFailure.run();
      
    }
    
  }
  
  // Only for admin purpose
//  public void getAllUsers(final UserListReceiver onSuccess, final Runnable onFailure) {
//    getUsers("/getUsers", onSuccess, onFailure);
//  }
//  
//  public void getOpenUsers(final UserListReceiver onSuccess, final Runnable onFailure) {
//    getUsers("/getUsers/openUser", onSuccess, onFailure);
//  }
//  
//  private void getUsers(final String path, UserListReceiver onSuccess, final Runnable onFailure) {
//    getUsers(path, new HashMap<String, String>(), onSuccess, onFailure);
//  }
//    
//  private void getUsers(final String path, final HashMap<String, String> parameters, UserListReceiver onSuccess, final Runnable onFailure) {
//    
//    try {
//      
//      final OnlineGameUser[] data = receiveJsonData(path, parameters, OnlineGameUser[].class);
//      
//      final List<OnlineGameUser> users = Arrays.asList(data);
//      
//      onSuccess.run(users);
//      
//    } catch (Exception e) {
//
//      logger.error("Error while receiving users!", e);
//      
//      onFailure.run();
//      
//    }
//    
//  }

}
