package de.kreawi.trainer.util;

public class OSDetector {
  
  public static enum EnumOS {
    linux, macos, solaris, unknown, windows;
    
    public boolean isLinux() {
      return this == linux || this == solaris;
    }
    
    public boolean isMac() {
      return this == macos;
    }
    
    public boolean isWindows() {
      return this == windows;
    }
  }
  
  public static EnumOS getOs() {
    
    String s = System.getProperty("os.name").toLowerCase();
    
    if (s.contains("win")) {
      return EnumOS.windows;
    }
    
    if (s.contains("mac")) {
      return EnumOS.macos;
    }
    
    if (s.contains("solaris")) {
      return EnumOS.solaris;
    }
    
    if (s.contains("sunos")) {
      return EnumOS.solaris;
    }
    
    if (s.contains("linux")) {
      return EnumOS.linux;
    }
    
    if (s.contains("unix")) {
      return EnumOS.linux;
    } else {
      return EnumOS.unknown;
    }
  }
  
}
