package de.kreawi.trainer.viewer;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JScrollPane;

import com.jgoodies.uif_lite.component.Factory;

public class ImageViewer extends ViewerWindow {

	private static final long serialVersionUID = 7100779064718395743L;

	private JScrollPane scrollPane;

	public ImageViewer(Component owner, String title, URL imagUrl)
			throws ViewerException {
		super(owner, title);

		JLabel label = new JLabel(new ImageIcon(imagUrl));
		this.scrollPane = Factory.createStrippedScrollPane(label);
		scrollPane.setOpaque(false);
		scrollPane.getViewport().setOpaque(false);
		sif.add(scrollPane, BorderLayout.CENTER);

		setVisible(true);
	}

	@Override
	public void setVisible(boolean b) {

		pack();

		int height = getPreferredSize().height;
		int width = getPreferredSize().width;

		if (height > getOwner().getHeight()) {
			height = getOwner().getHeight() - 20;
			width += this.scrollPane.getVerticalScrollBar().getMaximumSize()
					.getWidth();
		}

		if (width > getOwner().getWidth()) {
			width = getOwner().getWidth() - 20;
			height += this.scrollPane.getHorizontalScrollBar().getMaximumSize()
					.getHeight();
		}

		setPreferredSize(new Dimension(width, height));
		pack();
		setLocationRelativeTo(getOwner());

		super.setVisible(b);
	}

	public static boolean isImageUrl(URL url) {
		if (url == null) {
			return false;
		}

		String fileName = url.getFile().toLowerCase();

		return fileName.endsWith(".jpg") || fileName.endsWith(".gif") ||
				fileName.endsWith(".jpeg") || fileName.endsWith(".png");
	}

}
